// Generated by CoffeeScript 2.3.2
(function() {
  var Limiter, Transform;

  ({Transform} = require('stream'));

  // Roughly, no more than `count` messages per `interval` milliseconds.
  Limiter = class Limiter extends Transform {
    constructor(count, interval, options = {}) {
      options.objectMode = true;
      super(options);
      this.__count = count;
      this.__interval = interval;
      this.__current = 0;
      this.__start = Date.now();
    }

    _transform(chunk, encoding, next) {
      var end_of_period, now;
      now = Date.now();
      end_of_period = this.__start + this.__interval;
      this.__current++;
      // Reset the state if the interval expired.
      if (this.__current >= this.__count && now < end_of_period) {
        setTimeout((() => {
          this.__start = Date.now();
          this.__current = 1;
          this.push(chunk);
          return next();
        }), end_of_period - now);
        return;
      }
      if (now >= end_of_period) {
        this.__start = Date.now();
        this.__current = 1;
      }
      this.push(chunk);
      next();
    }

  };

  module.exports = Limiter;

}).call(this);
