// Generated by CoffeeScript 2.3.2
(function() {
  var CouchDB, Transform, expect;

  (({expect} = require('chai'))).should();

  CouchDB = require('most-couchdb');

  describe('The module', function() {
    it('should load', function() {
      require('../backend');
      return require('../attachments');
    });
    return it('should load utils', function() {
      require('../util/apply-command');
      require('../util/attachments-proxy');
      require('../util/build-backend');
      require('../util/count');
      require('../util/group');
      require('../util/query');
      require('../util/range');
      require('../util/semantic-for');
      return require('../util/view');
    });
  });

  ({Transform} = require('stream'));

  describe('View-as-stream', function() {
    var m, the_db;
    m = require('../util/view');
    the_db = new CouchDB(`http://${process.env.COUCHDB_USER}:${process.env.COUCHDB_PASSWORD}@127.0.0.1:5984/test`);
    before(async function() {
      return (await the_db.create());
    });
    after(async function() {
      return (await the_db.destroy());
    });
    it('should get a document', async function() {
      var v;
      await the_db.put({
        _id: 'hello',
        content: 'world'
      });
      v = m(the_db, null, '_all_docs', 'hello');
      return (await v.take(1).observe(function(doc) {
        return (expect(doc)).to.have.property('key', 'hello');
      }));
    });
    return it('should get a document with a limiter', async function() {
      var Limiter, limiter, received, v;
      await the_db.put({
        _id: 'hello2',
        content: 'world!',
        nothing: null,
        something: true,
        else: false
      });
      Limiter = require('./limiter');
      limiter = new Limiter(0, 10);
      v = m(the_db, null, '_all_docs', 'hello2', function() {
        return limiter;
      });
      received = 0;
      await v.observe(function(doc) {
        (expect(doc)).to.have.property('key', 'hello2');
        limiter.__current.should.eql(1);
        limiter.__start.should.gt(0);
        return received++;
      });
      return received.should.eql(1);
    });
  });

}).call(this);
