// Generated by CoffeeScript 2.3.2
(function() {
  // Web server
  // ----------
  var Cors, DOWNLOAD, REV, TOKEN, UNTIL, UPLOAD, URL, agent, assert, attachments_proxy, crypto, request, strictEqual;

  DOWNLOAD = 'get';

  UPLOAD = 'put';

  TOKEN = 'token';

  REV = 'rev';

  UNTIL = 'until';

  attachments_proxy = function(our_proxy) {
    var cors, download_uri, handler, hash, secret, signature, timeout, upload_uri, uri_maker;
    ({secret, hash, timeout} = our_proxy);
    cors = Cors();
    if (hash == null) {
      hash = 'sha256';
    }
    if (timeout == null) {
      timeout = 3600 * 1000; // one hour
    }
    signature = function(method, pathname, rev, limit) {
      strictEqual('string', typeof method, 'method');
      strictEqual('string', typeof pathname, 'pathname');
      strictEqual('string', typeof rev, 'rev');
      strictEqual('string', typeof limit, 'limit');
      return crypto.createHmac(hash, secret).update(method).update(pathname).update(rev).update(limit).digest('hex');
    };
    handler = function(req, res, next) {
      var limit, pathname, proxy, rev, searchParams, token;
      if (next == null) {
        next = function(msg) {
          res.writeHead(404);
          res.end(msg);
        };
      }
      proxy = function() {
        var method, options, the_proxy;
        ({method} = req);
        options = our_proxy.target(pathname);
        if ((options != null ? options.url : void 0) == null) {
          return next();
        }
        options.url.searchParams.set('rev', rev);
        options.url = options.url.toString();
        the_proxy = agent(Object.assign({
          method,
          followRedirects: false,
          maxRedirects: 0,
          headers: {
            Connection: 'close'
          }
        }, options));
        the_proxy.on('error', function(error) {
          return console.error('Proxy', method, options.url, error);
        });
        // req.socket.setKeepAlive true
        res.setHeader('Connection', 'close');
        req.on('end', function() {
          return the_proxy.end();
        });
        res.on('close', function() {
          return the_proxy.abort(); // this is the main one
        });
        req.pipe(the_proxy).pipe(res);
      };
      ({pathname, searchParams} = new URL(req.url, our_proxy.url));
      token = searchParams.get(TOKEN);
      if (token == null) {
        return next('Invalid token');
      }
      rev = searchParams.get(REV);
      if (rev == null) {
        return next('Invalid rev');
      }
      limit = searchParams.get(UNTIL);
      if (!((limit != null ? limit.match(/^\d+$/) : void 0) && parseInt(limit) > Date.now())) {
        return next(`Invalid limit ${JSON.stringify(limit)}`);
      }
      switch (req.method) {
        case 'OPTIONS':
          return cors(req, res, next);
        case 'PUT':
          if (token === signature(UPLOAD, pathname, rev, limit)) {
            return proxy();
          } else {
            return next("Invalid token");
          }
          break;
        case 'GET':
        case 'HEAD':
          if (token === signature(DOWNLOAD, pathname, rev, limit)) {
            return proxy();
          } else {
            return next("Invalid token");
          }
      }
      next();
    };
    uri_maker = function(direction) {
      return function(path, rev) {
        var limit, url;
        url = new URL(path, our_proxy.url);
        url.searchParams.set(REV, rev);
        limit = Date.now() + timeout;
        url.searchParams.set(UNTIL, limit);
        url.searchParams.set(TOKEN, signature(direction, path, rev, limit.toString()));
        return url.toString();
      };
    };
    download_uri = uri_maker(DOWNLOAD);
    upload_uri = uri_maker(UPLOAD);
    return {handler, download_uri, upload_uri};
  };

  module.exports = attachments_proxy;

  ({URL} = require('url'));

  crypto = require('crypto');

  request = require('request');

  agent = request.defaults({
    pool: false
  });

  Cors = require('cors');

  ({strictEqual} = assert = require('assert'));

}).call(this);
