// Generated by CoffeeScript 2.3.2
(function() {
  var apply_cmd, semantic_for;

  semantic_for = function(db, fromJS) {
    return {
      create: function(msg) {
        var doc;
        doc = msg.get('doc').set('_id', msg.get('id'));
        return db.put(doc.toJS()).catch(function() {
          return true;
        });
      },
      update: function(msg) {
        var id, msg_doc, operations, rev;
        id = msg.get('id');
        rev = msg.get('rev');
        msg_doc = msg.get('doc');
        operations = msg.get('operations');
        return db.get(id, {rev}).then(function(doc) {
          var old_doc;
          doc = fromJS(doc);
          old_doc = doc;
          if (msg_doc != null) {
            // The entries in the `.doc` field are interpreted as simple `set` operations.
            doc = doc.merge(msg_doc);
          }
          if (operations != null) {
            // The entries in the `.operations` field are executed by `json_path`.
            // Notice that these might fail, in which case the update will not be saved.
            doc = operations.reduce(apply_cmd, doc);
          }
          // Do not modify the database if the document was not modified.
          if (doc.equals(old_doc)) {
            return;
          }
          return db.put(doc.toJS());
        }).catch(function() {
          return true;
        });
      },
      delete: function(msg) {
        var id, rev;
        id = msg.get('id');
        rev = msg.get('rev');
        return db.delete({
          _id: id,
          _rev: rev
        }).catch(function() {
          return true;
        });
      }
    };
  };

  module.exports = semantic_for;

  apply_cmd = require('./apply-command');

}).call(this);
