// Generated by CoffeeScript 2.3.2
(function() {
  // View dispatcher
  // ---------------
  var Immutable, count, group, most, query, range, view_as_stream;

  view_as_stream = function(db, app, view, key, limiter) {
    var M, S, params, tap;
    params = null;
    tap = null;
    switch (false) {
      // - Map (JSON object) is used to provide one-time queries. These do not support `changes` streaming.
      // The `key` field (in the `SUBSCRIBE` message) is used to determine what type of query is performed:
      case !Immutable.Map.isMap(key):
        switch (false) {
          // For `group` queries we send the view's `key` in the `value` field of the message.
          // For view queries we need to keep the original `key` field (for routing purposes).
          case !key.has('level'):
            params = group(key.get('level'), key.get('min'), key.get('max'));
            tap = function(row) {
              [row.key, row.value] = [key, row.key];
            };
            break;
          // For count queries we set the `_key` field to the key generated by the view (the `value` field contains the view's `value`, i.e. the `count`).
          case !key.has('count'):
            params = count(key.get('count'), key.get('detail'));
            tap = function(row) {
              if (row.key != null) {
                [row.key, row._key] = [key, row.key];
              } else {
                row.key = key;
              }
            };
            break;
          // For range queries we set the `_key` field to the key generated by the view (the `value` field contains the view's `value`).
          case !(key.has('min') || key.has('max')):
            params = range(key.get('min'), key.get('max'));
            tap = function(row) {
              [row.key, row._key] = [key, row.key];
            };
        }
        break;
      default:
        // - string, List, etc., generate regular view queries (and are subject to `changes` streaming, see `most-couchdb/changes-view`).
        params = query(key);
    }
    if (params == null) {
      return most.empty();
    }
    S = db.queryStream(app, view, params);
    if (limiter != null) {
      if ('function' !== typeof limiter) {
        throw new Error(`limiter is ${typeof limiter}, expected a function`);
      }
      S = S.pipe(limiter());
    }
    S.on('error', console.error);
    M = most.fromEvent('data', S).until(most.fromEvent('end', S));
    if (tap != null) {
      M = M.tap(tap);
    }
    return M.multicast();
  };

  module.exports = view_as_stream;

  query = require('./query');

  count = require('./count');

  range = require('./range');

  group = require('./group');

  most = require('most');

  Immutable = require('immutable');

}).call(this);
